# file: makefmat.awk
# replacement for make-fmatch-matrix.awk
# written by: John M. Gravley
#
# This file expects the XXX.used-funcs file as input.
# It outputs a matrix of the form x(i,j) = 1 if functions i and j
#    are in the same file and 0 otherwise.  The matrix is a symmetric
#    matrix with the function names as the "indexes."
# A call would look like:
#	nawk -f makefmat.awk XXX.used-funcs
# The output is to stdout since the shell script that calls this
#   program handles where to send it.

# This program takes advantage of awk's associative array indexing.
# *** THIS PROGRAM REQUIRES NAWK ***

{
	# save the file name in an array indexed by function name
	in_file[$1] = $2
}

END {
	# debug = 1	# uncomment for debug output

	# reverse the order of output -- by default is backwards (i.e., sorted descending)
      	for (i in in_file) {
		in_file2[i] = in_file[i]
	}

	if (debug == 1) {
      		for (i in in_file2) {
			printf "%s %s\n", i, in_file2[i]
      		}
    	}

     	for (i in in_file2) {
	  	for (j in in_file2) {

	     		if (in_file2[i] == in_file2[j])
                 		printf "1 "
	     		else
		 		printf "0 "
	     	}
		printf "\n"
	}
}
