# file: makelbl.awk
# replacement for make-matrix-labels.awk
# written by: John M. Gravley
#
# This file expects the XXX.bind file as input.
# It outputs the function names contained in the XXX.bind file.
# It takes into account either func-i func-j var or
#   func-j func-i var in the input stream.
# It ignores var in either case.
# The output still needs to be sorted, so a call would look like:
#	nawk -f makelbl.awk XXX.bind | sort > XXX.labels

# This program takes advantage of awk's associative array indexing.
# *** THIS PROGRAM REQUIRES NAWK ***

{
	# not using the counts, just want to capture names
	theArray[$1] = 1
	theArray[$2] = 1
}

END {
	for (k in theArray) {
		print k
	}
}
