#ifndef __DISTANCE_H
#define __DISTANCE_H

#include "binding.h"
#include "suppvect.h"
#include "clustvect.h"
#include "tree.h"
#include "bclust.h"
#include "vectors.h"

typedef float ** Two_dim;

typedef struct{
		int dim_d;
		Two_dim d_mat;
	      }Dist_str;

typedef Dist_str * Dist_mat;

/* memory allocation for distance matrix */

Dist_mat createDistanceMatrix(int dim);

Dist_mat sCreateDistanceMatrix(float * dist_space, int dim);

void sFreeDistanceMatrix(Dist_mat dist);

void setDistValue(Dist_mat dist_mat, int row, int col, float value);

float getDistValue(Dist_mat dist_mat, int row, int col);

void resetDistanceMatrix(Dist_mat dist, float value);

/* distance computation as per Basili et-al's algorithm */

float computeDistance(Options state,  
			int no_of_clusts, 
			Cl_vect clust_vect, 
		     	I_vect suppress,
			Bind_mat bind, 
			Dist_mat dist_mat);


int traverseAndUpdate(Dist_mat dist,
		      float min_dist, 
		      I_vect suppress,
		      Cl_vect clust_vect, 
		      Tree_ptr tree, 
		      Options state);

void S_computeDistance(int *dimp,
			int *bind_mat,
			int *modep,
			float *dist_mat,
			int *debugp);

void printDistMatrix(Dist_mat dist, I_vect suppress);

#endif
    