#ifndef __GLOBALS_H
#define __GLOBALS_H

#define ABSURD 0		/* not a possible element/node */
#define INFINITY 99999

#define TRUE 1
#define FALSE 0

#define debugOption(state) state.debug
#define traceOption(state) state.trace
#define modeOption(state) state.mode
#define clusterOption(state) state.cluster
#define reorderOption(state) state.reorder

#define interfaceTest(option) (option.trace > 3)

#define setDebugOption(state, opt) state.debug = opt
#define setModeOption(state, opt) state.mode = opt
#define setTraceOption(state, opt) state.trace = opt
#define setClusterOption(state, opt) state.cluster = opt
#define setReorderOption(state, opt) state.reorder = opt

typedef struct stat_str {	/* structure for status */
	int debug;
	int trace;
	int mode;
	int cluster;
	int reorder;
	} Options;

typedef struct stat_str * Options_ptr;	/* ptr to status */


void * ecalloc();
void * emalloc();
Options setOptions( int debug,
		    int trace,
		    int mode,
		    int cluster,
		    int reorder);


#endif
