#ifndef __GOODNESS_H
#define __GOODNESS_H
#include "tree.h"
#include "vectors.h"
#include "distance.h"

typedef struct{
		R_vect ht_arr;
		Dist_mat sys_dist;
		int dim_g;
	      } Good_str;

typedef Good_str * Good_ptr;

Good_ptr createGoodnessStr(int dim);

Good_ptr sCreateGoodnessStr(float * pair_dist, int dim);

int traverseForAncestor(Tree_ptr tree,
				Good_ptr good,
                		int root, 
                		int left_num);

void pairwiseDistance(Tree_ptr tree,
			Good_ptr good,
			Options state);


void computePairwiseDistance(Good_ptr good,
				    Tree_ptr tree, 
				    int root, 
				    int left_num, 
				    int left_son_span, 
				    int right_son_span);

void constructHeightOfLeaves(Good_ptr good,
			     Tree_ptr tree);

void setHeightOfLeaf(Good_ptr good,
		      int pos,
		      float value);

float getHeightOfLeaf(Good_ptr good,
		      int pos);

void setDistBetweenLeaves(Good_ptr good,
			  int row,
			  int col,
			  float dist);

float getDistBetweenLeaves(Good_ptr good,
			   int row,
			   int col);

void printGoodnessStr(Good_ptr good);

#endif