/* fReadBindingMatrix()       */
/* Pruek Poolkasem, July 3,92 */
/*----------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "read_matrix.h"

int IntInLine( char line[] );
char *ReadLine (FILE *in_file, char target[]);
int  line2inta (char *line, Bind_mat bind_mat, int row);
char *skip_space(char *cp);
char *get_digit( char *cp, int *targetp);


Bind_mat   fReadBindingMatrix( char *file_name, int *dimp )
{
  	FILE *in_file;
  	Bind_mat bmatrix;
  	int r;
  	int n_int;
  	int dim;

  	char *line = (char *) malloc(MAX_LINE_SIZE);

  	if  ( (in_file = fopen(file_name, "r")) == NULL)  
	{
    	   printf("IN fReadBindingMatrix(): Cannot open file %s\n",
		  file_name);
    	   myError("...Exiting...");
  	}
  
  	if  (ReadLine (in_file, line)==NULL) 
	{
    	    printf ("IN: fReadBindingMatrix: input file %s is empty\n",
 		 file_name);
    	    myError("...Exiting....");
  	}

  	dim = IntInLine( line );
  	*dimp = dim;

  	bmatrix = createBindingMatrix( dim );

  	n_int = line2inta(line, bmatrix, 1);

  	for (r=2; r<= dim; r++) 
	{
    	    if  (ReadLine (in_file, line)==NULL) 
	    {
      	    	printf ("IN: fReadBindingMatrix: more row in %s is expected\n",
		    	file_name);
      	    	myError("...Exiting...");
    	    }
    	    n_int = line2inta(line, bmatrix, r);
    	    if  (n_int != dim) 
	    {
	    	printf ("In: fReadBindingMatrix: # of col in line %i is not 
			the same as line #1\n", r);
      	    	myError("...Exiting...");
    	    }
  	}
  	free (line);
  	fclose (in_file);
  	return bmatrix;
}



/* return NULL if eof is found */
char *ReadLine (FILE *in_file, char target[])
{
  	return fgets(target, MAX_LINE_SIZE, in_file);
}


/* return the number of integer found in the line */
/* line must end with 0 or \n */

int IntInLine( char line[] )
{
  	int tempi;
  	char *cp = line;
  	int  count = 0;
  	char *skip_space(char *cp);
  	char *get_digit( char *cp, int *targetp);

  	cp = skip_space(cp);
  	while ( (*cp!='\n') && (*cp!='\0') ) 
	{
    	     if  ( isdigit(*cp) ) 
	     {
      		cp = get_digit( cp, &tempi);
      		count += 1;
      		cp = skip_space(cp);
    	     } 
	     else 
	     {
      	     	printf ("IN line2inta: unexpected character found in the 
			matrix file\n");
      	     	myError("....Exiting...");
   	     }
  	}
  	return count; 
}



/* read numbers in the line into the integer array,'inta'. */
/* return number of int found */
/* assume that the line end with \n */

int  line2inta (char line[], Bind_mat bind_mat, int row)
{
  	char *cp = line;
  	int  count = 0;
	int dim = bind_mat->dim_b;
	int value;

  	cp = skip_space(cp);
  	while ( (*cp!='\n') && (*cp!='\0') ) 
	{
    	      if  ( isdigit(*cp) ) 
	      {
      		  cp = get_digit( cp, &value);
      		  count += 1;
		  readIntoBindMatrix(bind_mat, row, count, value);
     		  cp = skip_space(cp);
    	       } 
	       else 
	       {
      		   printf ("IN line2inta: unexpected character found in the 
			    matrix file\n");
      		   myError("...Exiting...");
    		}
  	}

  	return count;
}



char *skip_space(char *cp)
{
  	while (isspace(*cp)) cp++;
  	return cp;
}



/* read the digit from the position pointed to by 'cp' */
char *get_digit( char *cp, int *intp)
{
  	char digit_str[100];
  	char *targetp = digit_str;

  	while (isdigit(*cp)) 
	{
    	     *targetp = *cp;
    	     targetp++;
    	     cp++;
  	}
  	*targetp = 0;

  	*intp = atoi(digit_str);
    
  	return cp;
}

/*********************************
main(int argc, char **argv)
{
  	int * mat;
  	int size;
  	I_vect suppress;
	Bind_mat m;

  	printf ("%s\n", argv[1]);

  	m = fReadBindingMatrix( argv[1], &size );
	printf("Size = %d\n", size);

  	suppress = createIntVector(size);
	resetIntVector(suppress, ABSURD);
	printf("Dimension of Bind = %d\n", m->dim_b);
  	printBindMatrix(m, suppress);

}

***************************************/

