#ifndef __TREE_H
#define __TREE_H

#include "vectors.h"

#define leftnode(tree, x) getMergeValue(tree, x, 1)
#define rightnode(tree, x) getMergeValue(tree, x, 2)
#define isleaf(tree, x) (x < 0)

typedef int * Merge_vect;
typedef float * Height_vect;
typedef struct _Order_str{
			int dim_o;
			int order_pos;
			int * o_vect;
			  } Order_str;

typedef Order_str * Order_vect;

typedef struct _Tree_str{
			Merge_vect merge;
			Height_vect height;
			Order_vect order;
			I_vect merge_pos;
			int curr_pos;
			int size;
			} Tree_str;

typedef Tree_str * Tree_ptr;

Tree_ptr createTreeStr(int dim);

Tree_ptr sCreateTreeStr(Merge_vect merge,
			Height_vect height,
			int * order,
			int dim);

void destroyTreeStr(Tree_ptr tree);

void updateTreeStr(Tree_ptr tree,
			int member1,
			int member2,
			float min_dis);

int getClustFromTree(Tree_ptr tree);	/* total no of clusters formed */

void makeOrderFromMerge(Tree_ptr tree);	/* given merge construct order */

void makeOrderVector(Tree_ptr tree);

void printTreeStr(Tree_ptr tree);

/* added later to give access to goodness functions */

int getMergeValue(Tree_ptr tree,
		  int row, 
		  int col);

int getOrderValue(Tree_ptr tree,
			int pos);

float getHeightValue(Tree_ptr tree, int pos);

void sReconfigureLevels(Merge_vect merge_arr,
			Height_vect ht_arr,
			int * order_arr,
			int *dimp);

void reconfigureLevels(Tree_ptr tree);


#endif