#include <stdio.h>
#include "vectors.h"
#include "clustvect.h"
#include "globals.h"


I_vect createIntVector(int dim)
{
	I_vect ivect;

	ivect = (I_vect) emalloc(sizeof(I_str), "Int Vect");
	ivect->i_vect = (int *) ecalloc(dim, sizeof(int),"Int Vect");
	ivect->dim_i = dim;
	resetIntVector(ivect, ABSURD);
	return ivect;
}

R_vect createRealVector(int dim)
{
	R_vect rvect;

	rvect = (R_vect) emalloc(sizeof(R_str), "Real Vect");
	rvect->r_vect = (float *) ecalloc(dim, sizeof(float),"Real Vect");
	rvect->dim_r = dim;
	resetRealVector(rvect, R_ABSURD);
	return rvect;
}

void destroyIntVector(I_vect vect)
{
	free(vect->i_vect);
	free(vect);
}

void destroyRealVector(R_vect vect)
{
	free(vect->r_vect);
	free(vect);
}

void setIntVector(I_vect vect, int loc, int val)
{
	vect->i_vect[loc-1] = val;
}

void setRealVector(R_vect vect, int loc, float val)
{
	vect->r_vect[loc-1] = val;
}

void resetIntVector(I_vect vect, int val)
{
	int i;

	for (i = 1; i <= vect->dim_i; i++)
	{
	    setIntVector(vect, i, val);
	}
}

void resetRealVector(R_vect vect, float val)
{
	int i;

	for (i = 1; i <= vect->dim_r; i++)
	{
	    setRealVector(vect, i, val);
	}
}

int getIntValue(I_vect vect, int pos)
{
	return vect->i_vect[pos-1];
}


float getRealValue(R_vect vect, int pos)
{
	float val;
	val = vect->r_vect[pos-1];
	return val;
}

void printIntVector(I_vect vect, char * vect_name)
{
	int i;
	int val;

	printf("Printing Vector ..");
	printf("%s \n", vect_name);

	for (i = 1; i <= vect->dim_i; i++)
	{
	    val = getIntValue(vect, i);
	    printf("%d ", val);
	}
	printf("\n");
}
	
void printRealVector(R_vect vect, char * vect_name)
{
	int i;
	float val;

	printf("Printing Vector ..");
	printf("%s \n", vect_name);

	for (i = 1; i <= vect->dim_r; i++)
	{
	    val = getRealValue(vect, i);
	    printf("%2.2f ", val);
	}
	printf("\n");
}
