
goodness <- function(dmin, dmax, pDistance, fMatch, debug=0) 
     # dmin, dmax are the min and max distances at which elements
     # are clustered

     # pDistance is the pairwise distance matrix
     # computed by pairwiseDistance()

     # fMatch is a pairwise file match information.
     # a 0 indicates the elements are in different file
     # a 1 indicates the same file
{
      # goodness(e1,e2) = if (fileof(e1) = fileof(e2))
      #                   then (dmax-dmin) - pDistance(e1,e2)
      #                   else pDistance(eq, e2)
      #   where e 1= e2
      #     0 when e1 = e2
      # fMatch(e1,e2) == fileof(e1) = fileof(e2)
      # Therefore, goodness =  ((dmax-dmin) * fMatch) - pDistance

      if (debug) {
         print(paste("In goodness: dmax, dmin, fMatch", dmax, dmin))
         print(fMatch)
      }

      g <- abs((dmax-dmin) * fMatch - pDistance )
      diag(g) <- 0
      if (debug) {
         print("Goodness matrix ")
         print(g)
      }
      return(g)
}

systemGoodness <- function(dmin, dmax, pDistance, fMatch, debug=0) 
      # parameters as in goodness()
{
      # System goodness = SumOf(goodness(e1,e2)) where e1!=e2 / (n2-n)/drange
      #    where drange = dmax-dmin

      n <- nrow(pDistance)
      g <- goodness(dmin, dmax, pDistance, fMatch, debug)
      sum(g) /((n*n -n) * (dmax-dmin))
}

