

minpos <- function(x) {
  if (length(x) > 0) {
    minvalue <- min(x[x!=0])
    p <- c()
    for (i in 1:length(x)) {
        if (x[i] == minvalue) p <- c(p, i)
    }
   p
  } else x
}

na.rows <- function (x, whichdim=2) {
    x <- as.matrix(x)
    coord(x, (1:length(x))[is.na(x)], whichdim=whichdim)
}


coord <- function(x, indices, whichdim=0, filter=T) {
  if (length(indices) >0 & length(x) >0 ) {
    dims <- dim(x)
    ndims <- length(dims)
    nindices <- length(indices)

    xpliers <- vector("list", ndims)
    xpliers[1] <- 1
    if (ndims > 1) 
    for (i in 2:ndims) {
	xpliers[i] <-  prod(dims[1:i-1])
    }

    m <- data.frame(indices)

       index <- indices[1:nindices]-1
       for (j in ndims:1) {
           jcoord <- index %/% xpliers[[j]]
           index <- index %% xpliers[[j]]
           m.col <- dimnames(x)[[j]][jcoord+1]
           m <- data.frame(m, m.col)

       }
  if (whichdim > 0) {
       if (filter) 
          unique(as.vector(m[,whichdim+1, drop=T]))
       else
          as.vector(m[,whichdim+1, drop=T])
  } else    m[,2:(ndims+1)]
 
 } else data.frame()
}


drop.list.elements <- function(input, drop) {

   # Drops elements from a list of unique elements

   # Create an image list of the input such that
   #    input[i] = e <=> image.list[e] = i
   # The dimensions of the image list should be "character", hence the
   # paste(..)

  if (length(drop) > 0) {
    image.list <-  array(1:length(input), dimnames=list(paste(input)))

   # A negative numeric index has a special significance in S, which
   # allows us to drop the list elements
    input[- (image.list[paste(drop)]) ]
  } else input
}
